# drvAsynUSBHID

USB HIDデバイス用EPICS asynPortDriver

 * USBデバイスへのアクセスは[HIDAPI](https://github.com/signal11/hidapi)を使用
 * 制御コマンドは asyn + streamdeviceを使用
 * 65byte単位でのデータ送受信を行う
 * [drvAsynI2C](https://github.com/ffeldbauer/drvAsynI2C)を参考に作成

## 依存関係

 * EPICS base 3.14.12.5 (or newer)
 * asynDriver 4-26 (or newer)
 * HIDAPI

HIDAPIはOSでインストールする必要がある。
HIDAPI内部で使用するライブラリによって、インストール時のライブラリが変わる場合があるので注意。

## ドライバインストール

1. "configure/RELEASE"を環境に合わせて編集
2. "drvAsynUSBHIDApp/src/Makefile"をHIDAPIの環境に合わせて修正

defaultでは、hidapi-hidrawだが、環境によってはhidapi-libusbにする必要がある。
```sh
USR_INCLUDES += -fpermissive -Wsign-compare -I/usr/include/hidapi
PROD_LDLIBS  += -lhidapi-hidraw
```
3. 修正後、make


## 使い方

drvAsynUSBHIDを使ったIOCの作成方法。

### configure/RELEASE

環境に合わせて、asyn,streamdevice,drvAsynUSBHIDを追加する。
```sh
ASYN=$(EPICS_BASE)/../modules/soft/asyn
STREAM=$(EPICS_BASE)/../modules/soft/stream
DRVASYNUSBHID=$(TOP)/..
```

### xxxApp/src/Makefile

asyn,streamdevice,drvAsynUSBHIDとHIDAPIライブラリを追加する。

```sh
PROD_LDLIBS  += -lhidapi-hidraw
xxx_DBD += asyn.dbd
xxx_DBD += stream.dbd
xxx_DBD += drvAsynUSBHID.dbd
xxx_LIBS += asyn
xxx_LIBS += stream
xxx_LIBS += drvAsynUSBHID
```

PROD_LDLIBSはドライバと同じものを設定する。

### iocBoot/iocxxx/st.cmd

ドライバのロード設定。

```sh
drvAsynUSBHIDConfigure("NAME","vendor", "product", "serial", autoConnect)
```
 * "vendor"はUSBデバイスのベンダーID
 * "product"はUSBデバイスのプロダクトID
 * "serial"はUSBデバイスのシリアル番号。同じ種類のUSBデバイスを複数接続する場合には必要。不要な場合には""を設定。
 * autoConnectは自動接続設定。通常は"1"

