#ifndef __DRV_ASYN_USBHID_H__
#define __DRV_ASYN_USBHID_H__

#include <asynDriver.h>
#include <asynPortDriver.h>

#define MAX_STR 256
#define MAXCHAR 65

#define BYTE unsigned char
#define WORD unsigned short


class drvAsynUSBHID : public asynPortDriver {
 public:
  drvAsynUSBHID( const char *portName, const WORD vendorID, const WORD productID, const char *serialNo, int autoConnect);

  virtual asynStatus flushOctet( asynUser *pasynUser );
  virtual asynStatus readOctet( asynUser *pasynUser, char *value, size_t maxChars,
                                size_t *nActual, int *eomReason );
  virtual asynStatus writeOctet( asynUser *pasynUser, char const *value, size_t maxChars,
                                 size_t *nActual );
  virtual asynStatus connect( asynUser *pasynUser );
  virtual asynStatus disconnect( asynUser *pasynUser );

 private:
  hid_device	*hid_Hndl;
  WORD		vendor_id;
  WORD		product_id;
  char		*serial_no;
  asynInterface usbhid;

  char		deviceNameStr[MAX_STR];

};

#endif // __DRV_ASYN_USBHID_H__
